LeetCode(四)------Two Sum

  • 描述:
    Given an array of integers, find two numbers such that they add up to a specific target number.
    The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.
    You may assume that each input would have exactly one solution.
     Input: numbers={2, 7, 11, 15}, target=9
     Output: index1=1, index2=2

  • 思路:
    方法1:暴力,复杂度O(n ),会超时

    方法2:hash,复杂度 O(n) .使用一个HashMap,来建立数字和其坐标位置之间的映射,HashMap是常数级的查找效率,这样在遍历数组的时候,用target减去遍历到的数字,就是另一个需要的数字了,直接在HashMap中查找其是否存在即可,注意要判断查找到的数字不是第一个数字,比如target是4,遍历到了一个2,那么另外一个2不能是之前那个2,整个实现步骤为:先遍历一遍数组,建立HashMap映射,然后再遍历一遍,开始查找,找到则记录index。

    方法3:先排序,然后左右夹逼,排序O(n log n),左右夹逼 O(n) ,最终O(n log n)。但是注意,这题需要
    返回的是下标,而不是数字本身,因此这个方法行不通。

  • 示例代码:

// 方法2:hashmap,用一个哈希表,存储每个数对应的下标
// Time Complexity: O(n),Space Complexity: O(n)
public class Solution {
    public int[] twoSum(int[] nums, int target) {
        final HashMap<Integer, Integer> myMap = new HashMap<Integer, Integer>();
        int[] result = new int[2];
        for (int i = 0; i < nums.length; i++) {
            myMap.put(nums[i],i);
        }
        for (int i = 0; i < nums.length; i++) {
            final Integer v = myMap.get(target-nums[i]);
            //遍历到了一个数,那么另外一个数不能是当前这个数
            if (v != null && v > i) {
                return new int[]{i+1, v+1};
            }
        } 
        return null;
    }
}
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值